DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Protected Member Functions | Protected Attributes | Static Private Member Functions | Private Attributes | Friends | List of all members
DcmSequenceOfItems Class Reference

class representing a DICOM Sequence of Items (SQ). More...

Inheritance diagram for DcmSequenceOfItems:

## Public Member Functions
| DcmSequenceOfItems (const DcmTag &tag)
| constructor. More...
| DcmSequenceOfItems (const DcmSequenceOfItems &oldSeq)
| copy constructor More...
virtual | ~DcmSequenceOfItems ()
| destructor
DcmSequenceOfItems & | operator= (const DcmSequenceOfItems &obj)
| copy assignment operator More...
virtual int | compare (const DcmElement &rhs) const
| comparison operator that compares the normalized value of this object with a given object of the same type. More...
OFCondition | error () const
| returns current status flag
virtual DcmObject * | clone () const
| clone method More...
virtual OFCondition | copyFrom (const DcmObject &rhs)
| Virtual object copying. More...
virtual DcmEVR | ident () const
| return identifier for this class. More...
virtual OFBool | isLeaf () const
| check if this element is a leaf node in a dataset tree. More...
virtual void | print (STD_NAMESPACE ostream &out, const size_t flags=0, const int level=0, const char *pixelFileName=NULL, size_t *pixelCounter=NULL)
| print object to a stream More...
virtual OFCondition | checkValue (const OFString &card="1-n", const OFBool oldFormat=OFFalse)
| check whether stored value conforms to the VR and to the specified VM More...
virtual unsigned long | getVM ()
| get value multiplicity More...
virtual unsigned long | getNumberOfValues ()
| get number of values (items) stored in this sequence. More...
virtual unsigned long | card () const
| get cardinality of this sequence More...
virtual OFCondition | computeGroupLengthAndPadding (const E_GrpLenEncoding glenc, const E_PaddingEncoding padenc=EPD_noChange, const E_TransferSyntax xfer=EXS_Unknown, const E_EncodingType enctype=EET_ExplicitLength, const Uint32 padlen=0, const Uint32 subPadlen=0, Uint32 instanceLength=0)
| This function takes care of group length and padding elements in the current element list according to what is specified in glenc and padenc. More...
virtual Uint32 | calcElementLength (const E_TransferSyntax xfer, const E_EncodingType enctype)
| calculate the length of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences. More...
virtual Uint32 | getLength (const E_TransferSyntax xfer=EXS_LittleEndianImplicit, const E_EncodingType enctype=EET_UndefinedLength)
| calculate the value length (without attribute tag, VR and length field) of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences. More...
virtual void | transferInit ()
| initialize the transfer state of this object. More...
virtual void | transferEnd ()
| finalize the transfer state of this object. More...
virtual OFBool | canWriteXfer (const E_TransferSyntax oldXfer, const E_TransferSyntax newXfer)
| check if this DICOM object can be encoded in the given transfer syntax. More...
virtual OFCondition | read (DcmInputStream &inStream, const E_TransferSyntax xfer, const E_GrpLenEncoding glenc=EGL_noChange, const Uint32 maxReadLength=DCM_MaxReadLength)
| This function reads the information of all attributes which are captured in the input stream and captures this information in elementList. More...
virtual OFCondition | write (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| write object to a stream More...
virtual OFCondition | writeXML (STD_NAMESPACE ostream &out, const size_t flags=0)
| write object in XML format More...
virtual OFCondition | writeJson (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write object in JSON format More...
virtual OFCondition | writeSignatureFormat (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| special write method for creation of digital signatures More...
virtual OFBool | isSignable () const
| returns true if the current object may be included in a digital signature More...
virtual OFBool | containsUnknownVR () const
| returns true if the object contains an element with Unknown VR at any nesting level More...
virtual OFBool | containsExtendedCharacters (const OFBool checkAllStrings=OFFalse)
| check if this object contains non-ASCII characters at any nesting level. More...
virtual OFBool | isAffectedBySpecificCharacterSet () const
| check if this object is affected by SpecificCharacterSet at any nesting level. More...
virtual OFCondition | convertCharacterSet (DcmSpecificCharacterSet &converter)
| convert all element values that are contained in this item and that are affected by SpecificCharacterSet from the currently selected source character set to the currently selected destination character set More...
virtual OFCondition | prepend (DcmItem *item)
| insert the given item at the start of the item list maintained by this sequence. More...
virtual OFCondition | insert (DcmItem *item, unsigned long where=DCM_EndOfListIndex, OFBool before=OFFalse)
| insert the given item at the given position within the item list maintained by this sequence. More...
virtual OFCondition | append (DcmItem *item)
| insert the given item at the end of the item list maintained by this sequence. More...
virtual OFCondition | insertAtCurrentPos (DcmItem *item, OFBool before=OFFalse)
| insert new item a current position. More...
virtual DcmItem * | getItem (const unsigned long num)
| access an item from the sequence. More...
virtual OFCondition | nextObject (DcmStack &stack, const OFBool intoSub)
| this method enables a stack based, depth-first traversal of a complete hierarchical DICOM dataset (that is, classes derived from DcmItem or DcmSequenceOfItems). More...
virtual DcmObject * | nextInContainer (const DcmObject *obj)
| this method is only used in container classes, that is, DcmItem and DcmSequenceOfItems. More...
virtual DcmItem * | remove (const unsigned long num)
| remove item from list. More...
virtual DcmItem * | remove (DcmItem *item)
| remove item from list. More...
virtual OFBool | isEmpty (const OFBool normalize=OFTrue)
| check if this sequence is empty More...
virtual OFCondition | clear ()
| clear (remove) attribute value More...
virtual OFCondition | verify (const OFBool autocorrect=OFFalse)
| check the currently stored element value More...
virtual OFCondition | search (const DcmTagKey &xtag, DcmStack &resultStack, E_SearchMode mode=ESM_fromHere, OFBool searchIntoSub=OFTrue)
| a complex, stack-based, hierarchical search method. More...
virtual OFCondition | loadAllDataIntoMemory (void)
| this method loads all attribute values maintained by this object and all sub-objects (in case of a container such as DcmDataset) into memory. More...
virtual OFCondition | getPartialValue (void *targetBuffer, const Uint32 offset, Uint32 numBytes, DcmFileCache *cache=NULL, E_ByteOrder byteOrder=gLocalByteOrder)
| Copy numBytes bytes of data from the attribute value in byteOrder byte order to targetBuffer, starting at byte offset offset of the attribute value. More...
Public Member Functions inherited from DcmElement
| DcmElement (const DcmTag &tag, const Uint32 len=0)
| constructor. More...
| DcmElement (const DcmElement &old)
| copy constructor More...
virtual | ~DcmElement ()
| destructor
DcmElement & | operator= (const DcmElement &obj)
| assignment operator More...
virtual OFBool | isElement () const
| check if this element can be safely casted to DcmElement More...
OFBool | valueLoaded () const
| check if value of this element is loaded into main memory More...
virtual OFCondition | getUint8 (Uint8 &val, const unsigned long pos=0)
| retrieve a single value of type Uint8. More...
virtual OFCondition | getSint16 (Sint16 &val, const unsigned long pos=0)
| retrieve a single value of type Sint16. More...
virtual OFCondition | getUint16 (Uint16 &val, const unsigned long pos=0)
| retrieve a single value of type Uint16. More...
virtual OFCondition | getSint32 (Sint32 &val, const unsigned long pos=0)
| retrieve a single value of type Sint32. More...
virtual OFCondition | getUint32 (Uint32 &val, const unsigned long pos=0)
| retrieve a single value of type Uint32. More...
virtual OFCondition | getFloat32 (Float32 &val, const unsigned long pos=0)
| retrieve a single value of type Float32. More...
virtual OFCondition | getSint64 (Sint64 &val, const unsigned long pos=0)
| retrieve a single value of type Sint64. More...
virtual OFCondition | getUint64 (Uint64 &val, const unsigned long pos=0)
| retrieve a single value of type Uint64. More...
virtual OFCondition | getFloat64 (Float64 &val, const unsigned long pos=0)
| retrieve a single value of type Float64. More...
virtual OFCondition | getTagVal (DcmTagKey &val, const unsigned long pos=0)
| retrieve a single value of type DcmTagKey. More...
virtual OFCondition | getOFString (OFString &str, const unsigned long pos, OFBool normalize=OFTrue)
| retrieve a single value of type string. More...
virtual OFCondition | getOFStringArray (OFString &value, OFBool normalize=OFTrue)
| get entire element value as a character string. More...
virtual OFCondition | getString (char *&val)
| get a pointer to the element value of the current element as type string. More...
virtual OFCondition | getString (char *&val, Uint32 &len)
| get a pointer to the element value of the current element as type string. More...
virtual OFCondition | getUint8Array (Uint8 *&val)
| get a pointer to the element value of the current element as type string. More...
virtual OFCondition | getSint16Array (Sint16 *&val)
| get a pointer to the element value of the current element as type Sint16. More...
virtual OFCondition | getUint16Array (Uint16 *&val)
| get a pointer to the element value of the current element as type Uint16. More...
virtual OFCondition | getSint32Array (Sint32 *&val)
| get a pointer to the element value of the current element as type Sint32. More...
virtual OFCondition | getUint32Array (Uint32 *&val)
| get a pointer to the element value of the current element as type Uint32. More...
virtual OFCondition | getFloat32Array (Float32 *&val)
| get a pointer to the element value of the current element as type Float32. More...
virtual OFCondition | getSint64Array (Sint64 *&val)
| get a pointer to the element value of the current element as type Sint64. More...
virtual OFCondition | getUint64Array (Uint64 *&val)
| get a pointer to the element value of the current element as type Uint64. More...
virtual OFCondition | getFloat64Array (Float64 *&val)
| get a pointer to the element value of the current element as type Float64. More...
OFCondition | detachValueField (OFBool copy=OFFalse)
| detach the value field from the DICOM element (i.e., this object). More...
virtual OFCondition | putOFStringArray (const OFString &val)
| replace the element value by a copy of the given string (which is possibly multi-valued). More...
virtual OFCondition | putString (const char *val)
| replace the element value by a copy of the given string (which is possibly multi-valued). More...
virtual OFCondition | putString (const char *val, const Uint32 len)
| replace the element value by a copy of the given string (which is possibly multi-valued). More...
virtual OFCondition | putSint16 (const Sint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint16 value. More...
virtual OFCondition | putUint16 (const Uint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint16 value. More...
virtual OFCondition | putSint32 (const Sint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint32 value. More...
virtual OFCondition | putUint32 (const Uint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint32 value. More...
virtual OFCondition | putFloat32 (const Float32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float32 value. More...
virtual OFCondition | putSint64 (const Sint64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint64 value. More...
virtual OFCondition | putUint64 (const Uint64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint64 value. More...
virtual OFCondition | putFloat64 (const Float64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float64 value. More...
virtual OFCondition | putTagVal (const DcmTagKey &attrTag, const unsigned long pos=0)
| insert into the element value a copy of the given DcmTagKey value. More...
virtual OFCondition | putUint8Array (const Uint8 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint8 array (which is possibly multi-valued). More...
virtual OFCondition | putSint16Array (const Sint16 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint16 array (which is possibly multi-valued). More...
virtual OFCondition | putUint16Array (const Uint16 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint16 array (which is possibly multi-valued). More...
virtual OFCondition | putSint32Array (const Sint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint32 array (which is possibly multi-valued). More...
virtual OFCondition | putUint32Array (const Uint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint32 array (which is possibly multi-valued). More...
virtual OFCondition | putFloat32Array (const Float32 *vals, const unsigned long num)
| replace the element value by a copy of the given Float32 array (which is possibly multi-valued). More...
virtual OFCondition | putSint64Array (const Sint64 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint64 array (which is possibly multi-valued). More...
virtual OFCondition | putUint64Array (const Uint64 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint64 array (which is possibly multi-valued). More...
virtual OFCondition | putFloat64Array (const Float64 *vals, const unsigned long num)
| replace the element value by a copy of the given Float64 array (which is possibly multi-valued). More...
virtual OFCondition | createUint8Array (const Uint32 numBytes, Uint8 *&bytes)
| create an empty Uint8 array of given number of bytes and set it. More...
virtual OFCondition | createUint16Array (const Uint32 numWords, Uint16 *&words)
| create an empty Uint16 array of given number of words and set it. More...
virtual OFCondition | createValueFromTempFile (DcmInputStreamFactory *factory, const Uint32 length, const E_ByteOrder byteOrder)
| replace the attribute value with the content of the given temporary file. More...
virtual void | compact ()
| remove the attribute value from memory if the attribute value can be loaded from file when needed again. More...
virtual OFCondition | getUncompressedFrameSize (DcmItem *dataset, Uint32 &frameSize, OFBool pixelDataIsUncompressed) const
| compute uncompressed frame size of a single frame of this image. More...
virtual OFCondition | getUncompressedFrame (DcmItem *dataset, Uint32 frameNo, Uint32 &startFragment, void *buffer, Uint32 bufSize, OFString &decompressedColorModel, DcmFileCache *cache=NULL)
| access single frame without decompressing or loading a complete multi-frame object. More...
virtual OFCondition | getDecompressedColorModel (DcmItem *dataset, OFString &decompressedColorModel)
| determine color model of the decompressed image More...
virtual OFBool | isUniversalMatch (const OFBool normalize=OFTrue, const OFBool enableWildCardMatching=OFTrue)
| Determine if this element is universal matching. More...
virtual OFBool | matches (const DcmElement &candidate, const OFBool enableWildCardMatching=OFTrue) const
| perform attribute matching. More...
virtual OFBool | combinationMatches (const DcmElement &keySecond, const DcmElement &candidateFirst, const DcmElement &candidateSecond) const
| perform combined attribute matching. More...
const DcmInputStreamFactory * | getInputStream () const
| returns a pointer to the input stream, if available, NULL otherwise. More...
virtual Uint16 | decodedBitsAllocated (Uint16 bitsAllocated, Uint16 bitsStored) const
| determines the effective value of BitsAllocated that a dataset will have after decompression of an image with the given values for bitsAllocated and bitsStored. More...
Public Member Functions inherited from DcmObject
| DcmObject (const DcmTag &tag, const Uint32 len=0)
| constructor. More...
| DcmObject (const DcmObject &obj)
| copy constructor More...
virtual | ~DcmObject ()
| destructor
DcmObject & | operator= (const DcmObject &obj)
| copy assignment operator More...
DcmEVR | getVR () const
| return the value representation assigned to this object. More...
OFBool | isaString () const
| check if this element is a string type, based on the VR. More...
virtual OFBool | isNested () const
| check if this element is nested in a sequence of items, i.e. not a top-level or stand-alone element More...
E_TransferState | transferState () const
| return the current transfer (read/write) state of this object. More...
DcmItem * | getRootItem ()
| get root dataset/item (top-level) that contains this object. More...
virtual DcmItem * | getParentItem ()
| get parent item of this object. More...
DcmObject * | getParent ()
| get parent of this object. More...
const DcmObject * | getParent () const
| get parent of this object. More...
void | setParent (DcmObject *parent)
| set parent of this object. More...
Uint16 | getGTag () const
| return the group number of the attribute tag for this object More...
Uint16 | getETag () const
| return the element number of the attribute tag for this object More...
const DcmTag & | getTag () const
| return const reference to the attribute tag for this object More...
void | setGTag (Uint16 gtag)
| assign group tag (but not element tag) of the attribute tag for this object. More...
virtual OFCondition | setVR (DcmEVR vr)
| assign a new Value Representation (VR) to this object. More...
Uint32 | getLengthField () const
| return the current value of the Length field (which is different from the functionality of the public getLength() method). More...

## Protected Member Functions
| DcmSequenceOfItems (const DcmTag &tag, const Uint32 len, OFBool readAsUN=OFFalse)
| constructor. More...
virtual OFCondition | readTagAndLength (DcmInputStream &inStream, const E_TransferSyntax xfer, DcmTag &tag, Uint32 &length)
| This function reads tag and length information from inStream and returns this information to the caller. More...
virtual OFCondition | makeSubObject (DcmObject *&subObject, const DcmTag &newTag, const Uint32 newLength)
| helper function for read(). More...
OFCondition | readSubItem (DcmInputStream &inStream, const DcmTag &newTag, const Uint32 newLength, const E_TransferSyntax xfer, const E_GrpLenEncoding glenc, const Uint32 maxReadLength=DCM_MaxReadLength)
| helper function for read(). More...
virtual OFCondition | searchSubFromHere (const DcmTagKey &tag, DcmStack &resultStack, const OFBool searchIntoSub)
| helper function for search(). More...
Protected Member Functions inherited from DcmElement
void * | getValue (const E_ByteOrder newByteOrder=gLocalByteOrder)
| This function returns this element's value. More...
OFCondition | changeValue (const void *value, const Uint32 position, const Uint32 num)
| insert into the element value a copy of the given raw value. More...
OFCondition | putValue (const void *value, const Uint32 length)
| replace the element value by a copy of the given raw data block More...
OFCondition | createEmptyValue (const Uint32 length)
| create a new, empty value field of given size. More...
OFCondition | loadValue (DcmInputStream *inStream=NULL)
| This function reads the data value of an attribute and stores the information which was read in this. More...
virtual void | postLoadValue ()
| performs clean-up functions after loading an attribute value into main memory. More...
virtual Uint8 * | newValueField ()
| This function creates a byte array of Length bytes and returns this array. More...
void | swapValueField (size_t valueWidth)
| swaps the content of the value field (if loaded) from big-endian to little-endian or back More...
virtual void | writeXMLStartTag (STD_NAMESPACE ostream &out, const size_t flags, const char *attrText=NULL)
| write element start tag in XML format More...
virtual void | writeXMLEndTag (STD_NAMESPACE ostream &out, const size_t flags)
| write element end tag in XML format More...
virtual void | writeJsonOpener (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element start tag in JSON format More...
virtual void | writeJsonCloser (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element end tag in JSON format More...
E_ByteOrder | getByteOrder () const
| return the current byte order of the value field More...
void | setByteOrder (E_ByteOrder val)
| set the current byte order of the value field More...
Protected Member Functions inherited from DcmObject
void | printNestingLevel (STD_NAMESPACE ostream &out, const size_t flags, const int level)
| print line indentation, e.g. a couple of spaces for each nesting level. More...
void | printInfoLineStart (STD_NAMESPACE ostream &out, const size_t flags, const int level, DcmTag *tag=NULL)
| print beginning of the info line. More...
void | printInfoLineEnd (STD_NAMESPACE ostream &out, const size_t flags, const unsigned long printedLength=0xffffffff, DcmTag *tag=NULL)
| print end of the info line. More...
virtual void | printInfoLine (STD_NAMESPACE ostream &out, const size_t flags, const int level=0, const char *info=NULL, DcmTag *tag=NULL, const OFBool isInfo=OFTrue)
| print given text with element information. More...
virtual OFCondition | writeTagAndLength (DcmOutputStream &outStream, const E_TransferSyntax oxfer, Uint32 &writtenBytes) const
| write tag, VR and length field to the given output stream More...
virtual Uint32 | getTagAndLengthSize (const E_TransferSyntax oxfer) const
| return the number of bytes needed to serialize the tag, VR and length information of the current object using the given transfer syntax. More...
const char * | getTagName ()
| return the DICOM attribute tag name for this object. More...
void | setTagVR (DcmEVR vr)
| set the VR for this attribute More...
E_TransferState | getTransferState () const
| return the current transfer state of this object during serialization/deserialization More...
void | setTransferState (E_TransferState newState)
| set the current transfer state of this object during serialization/deserialization More...
Uint32 | getTransferredBytes () const
| return the number of transferred bytes for this object during serialization/deserialization More...
void | setTransferredBytes (Uint32 val)
| set the number of transferred bytes for this object during serialization/deserialization More...
void | incTransferredBytes (Uint32 val)
| add to the number of transferred bytes for this object during serialization/deserialization More...
void | setLengthField (Uint32 val)
| set the current value of the Length field More...

## Protected Attributes
DcmList * | itemList
| the list of items maintained by this sequence object
Protected Attributes inherited from DcmObject
OFCondition | errorFlag
| error flag for this object.

## Static Private Member Functions
static OFCondition | writeTagAndVR (DcmOutputStream &outStream, const DcmTag &tag, DcmEVR vr, const E_TransferSyntax oxfer)
| static helper method used in writeSignatureFormat(). More...

## Private Attributes
OFBool | lastItemComplete
| flag used during suspended I/O. More...
offile_off_t | fStartPosition
| used during reading. More...
OFBool | readAsUN_
| true if this sequence has been instantiated while reading an UN element with undefined length

## Friends
class | DcmItem

## Additional Inherited Members
Static Public Member Functions inherited from DcmElement
static int | scanValue (const OFString &value, const OFString &vr, const size_t pos=0, const size_t num=OFString_npos)
| scan string value for conformance with given value representation (VR) More...
static int | scanValue (const OFString &vr, const char *const value, const size_t size)
| scan string value for conformance with given value representation (VR) More...
static unsigned long | determineVM (const char *str, const size_t len)
| determine the number of values stored in a string, i.e. the value multiplicity (VM) More...
static size_t | getValueFromString (const char *str, const size_t pos, const size_t len, OFString &val)
| get the first value stored in the given string. More...
static OFCondition | checkVM (const unsigned long vmNum, const OFString &vmStr)
| check for correct value multiplicity (VM) More...
Static Protected Member Functions inherited from DcmObject
static OFCondition | writeTag (DcmOutputStream &outStream, const DcmTag &tag, const E_TransferSyntax oxfer)
| static helper function that writes a given attribute tag to a binary output stream using the byte order indicated by the transfer syntax. More...

## Detailed Description

class representing a DICOM Sequence of Items (SQ).

This class is derived from class DcmElement (and not from DcmObject) despite the fact that sequences have no value field as such, they maintain a list of items. However, all APIs in class DcmItem and class DcmDataset accept DcmElements. This is ugly and causes some DcmElement API methods to be useless with DcmSequence.

## Constructor & Destructor Documentation

## ◆ DcmSequenceOfItems() [1/3]

DcmSequenceOfItems::DcmSequenceOfItems | ( | const DcmTag & | tag | ) |

constructor.

Create new element from given tag.

Parameters

  tag | attribute tag

## ◆ DcmSequenceOfItems() [2/3]

DcmSequenceOfItems::DcmSequenceOfItems | ( | const DcmSequenceOfItems & | oldSeq | ) |

copy constructor

Parameters

  oldSeq | element to be copied

## ◆ DcmSequenceOfItems() [3/3]

DcmSequenceOfItems::DcmSequenceOfItems | ( | const DcmTag & | tag,
|  | const Uint32 | len,
|  | OFBool | readAsUN = `OFFalse`
| ) |  |
| protected

constructor.

Create new element from given tag and length. Only reachable from friend classes since construction with length different from 0 leads to a state with length being set but the element's value still being uninitialized. This can lead to crashes when the value is read or written. Thus the method calling this constructor with length > 0 must ensure that the element's value is explicitly initialized, too.

Parameters

  tag | attribute tag
  len | length of the attribute value
  readAsUN | flag indicating whether the sequence should be read (interpreted) as a UN element with Implicit VR Little Endian encoding

## Member Function Documentation

## ◆ append()

virtual OFCondition DcmSequenceOfItems::append | ( | DcmItem * | item | ) |
| virtual

insert the given item at the end of the item list maintained by this sequence.

Ownership of the item, which must be allocated on the heap, is transferred to the sequence.

Parameters

  item | pointer to DcmItem instance allocated on the heap, must not be NULL.

Returns
  EC_Normal if successful, an error code otherwise

## ◆ calcElementLength()

virtual Uint32 DcmSequenceOfItems::calcElementLength | ( | const E_TransferSyntax | xfer,
|  | const E_EncodingType | enctype
| ) |  |
| virtual

calculate the length of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences.

For elements, the length includes the length of the tag, length field, VR field and the value itself, for items and sequences it returns the length of the complete item or sequence including delimitation tags if applicable.

Warning
  Since calcElementLength() returns a 32 bit integer, an overflow during calculation is possible for some derived classes that actually represent a compound value (e.g. items like DcmPixelItem). Such overflows will be detected, in which case the maximum possible value will be returned instead, coinciding with DCM_UndefinedLength.
  The implementation in DcmPixelData may return zero if no conforming representation exists and set the EC_RepresentationNotFound error flag to indicated it.
  When calculation the length of a sequence or an item containing multiple attributes, the implementation may return DCM_UndefinedLength to indicate a value that can not be encoded as a 32 bit length field. It will even do so if "dcmWriteOversizedSeqsAndItemsUndefined" is disabled, but then also set the EC_SeqOrItemContentOverflow error flag (inside getLength()) to indicated it.

Note
  Just check for zero or DCM_UndefinedLength return value and then have a look at the error flag in either case.

Parameters

  xfer | transfer syntax for length calculation
  enctype | sequence encoding type for length calculation

Returns
  length of DICOM element

Reimplemented from DcmElement.

Reimplemented in DcmPixelSequence, and DcmFileFormat.

## ◆ canWriteXfer()

virtual OFBool DcmSequenceOfItems::canWriteXfer | ( | const E_TransferSyntax | oldXfer,
|  | const E_TransferSyntax | newXfer
| ) |  |
| virtual

check if this DICOM object can be encoded in the given transfer syntax.

Parameters

  newXfer | transfer syntax in which the DICOM object is to be encoded
  oldXfer | transfer syntax in which the DICOM object was read or created.

Returns
  true if object can be encoded in desired transfer syntax, false otherwise.

Reimplemented from DcmElement.

Reimplemented in DcmFileFormat, and DcmPixelSequence.

## ◆ card()

virtual unsigned long DcmSequenceOfItems::card | ( |  | ) | const
| virtual

get cardinality of this sequence

Returns
  number of items in this sequence

## ◆ checkValue()

virtual OFCondition DcmSequenceOfItems::checkValue | ( | const OFString & | card = `"1-n"`,
|  | const OFBool | oldFormat = `OFFalse`
| ) |  |
| virtual

check whether stored value conforms to the VR and to the specified VM

Parameters

  card | cardinality (number of items) to be checked for. (See DcmElement::checkVM() for a list of valid values.) Parameter used to specify the value multiplicity for non-sequence attributes.
  oldFormat | parameter not used for this VR (only for DA, TM)

Returns
  status of the check, EC_Normal if value is correct, an error code otherwise

Reimplemented from DcmElement.

## ◆ clear()

virtual OFCondition DcmSequenceOfItems::clear | ( |  | ) |
| virtual

clear (remove) attribute value

Returns
  EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmFileFormat.

## ◆ clone()

virtual DcmObject* DcmSequenceOfItems::clone | ( |  | ) | const
| inline virtual

clone method

Returns
  deep copy of this object

Implements DcmObject.

Reimplemented in DcmPixelSequence, and DcmFileFormat.

## ◆ compare()

virtual int DcmSequenceOfItems::compare | ( | const DcmElement & | rhs | ) | const
| virtual

comparison operator that compares the normalized value of this object with a given object of the same type.

The tag of the element is also considered as the first component that is compared, followed by the object types (VR, i.e. DCMTK'S EVR) and the comparison of all value components of the object, preferably in the order declared in the object (if applicable). For sequences that means that all contained items are compared element by element, so this may be an expensive operation!

Parameters

  rhs | the right hand side of the comparison

Returns
  0 if the object values are equal. -1 if this element has fewer components than the rhs element. Also -1 if the value of the first component that does not match is lower in this object than in rhs. Also returned if rhs cannot be casted to this object type or both objects are of different VR (i.e. the DcmEVR returned by the element's ident() call are different). 1 if either this element has more components than the rhs element, or if the first component that does not match is greater in this object than in rhs object.

Implements DcmElement.

## ◆ computeGroupLengthAndPadding()

virtual OFCondition DcmSequenceOfItems::computeGroupLengthAndPadding | ( | const E_GrpLenEncoding | glenc,
|  | const E_PaddingEncoding | padenc = `EPD_noChange`,
|  | const E_TransferSyntax | xfer = `EXS_Unknown`,
|  | const E_EncodingType | enctype = `EET_ExplicitLength`,
|  | const Uint32 | padlen = `0`,
|  | const Uint32 | subPadlen = `0`,
|  | Uint32 | instanceLength = `0`
| ) |  |
| virtual

This function takes care of group length and padding elements in the current element list according to what is specified in glenc and padenc.

If required, this function does the following two things: a) it calculates the group length of all groups which are contained in this item and sets the calculated values in the corresponding group length elements and b) it inserts a corresponding padding element (or, in case of sequences: padding elements) with a corresponding correct size into the element list.

Parameters

  glenc | Encoding type for group length; specifies what shall be done with group length tags.
  padenc | Encoding type for padding; specifies what shall be done with padding tags.
  xfer | The transfer syntax that shall be used.
  enctype | Encoding type for sequences; specifies how sequences will be handled.
  padlen | The length up to which the dataset shall be padded, if padding is desired.
  subPadlen | For sequences (ie sub elements), the length up to which item shall be padded, if padding is desired.
  instanceLength | Number of extra bytes added to the item/dataset length used when computing the padding; this parameter is for instance used to pass the length of the file meta header from the DcmFileFormat to the DcmDataset object.

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ containsExtendedCharacters()

virtual OFBool DcmSequenceOfItems::containsExtendedCharacters | ( | const OFBool | checkAllStrings = `OFFalse` | ) |
| virtual

check if this object contains non-ASCII characters at any nesting level.

Please note that this check is pretty simple and only works for single-byte character sets that do include the 7-bit ASCII codes, e.g. for the ISO 8859 family. In other words: All character codes below 128 are considered to be ASCII codes and all others are considered to be non-ASCII.

Parameters

  checkAllStrings | if true, also check elements with string values not affected by SpecificCharacterSet (0008,0005). By default, only check PN, LO, LT, SH, ST, UC and UT.

Returns
  true if object contains non-ASCII characters, false otherwise

Reimplemented from DcmObject.

## ◆ containsUnknownVR()

virtual OFBool DcmSequenceOfItems::containsUnknownVR | ( |  | ) | const
| virtual

returns true if the object contains an element with Unknown VR at any nesting level

Returns
  true if the object contains an element with Unknown VR, false otherwise

Reimplemented from DcmObject.

## ◆ convertCharacterSet()

virtual OFCondition DcmSequenceOfItems::convertCharacterSet | ( | DcmSpecificCharacterSet & | converter | ) |
| virtual

convert all element values that are contained in this item and that are affected by SpecificCharacterSet from the currently selected source character set to the currently selected destination character set

Parameters

  converter | character set converter to be used to convert the element values

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmObject.

Reimplemented in DcmFileFormat.

## ◆ copyFrom()

virtual OFCondition DcmSequenceOfItems::copyFrom | ( | const DcmObject & | rhs | ) |
| virtual

Virtual object copying.

This method can be used for DcmObject and derived classes to get a deep copy of an object. Internally the assignment operator is called if the given DcmObject parameter is of the same type as "this" object instance. If not, an error is returned. This function permits copying an object by value in a virtual way which therefore is different to just calling the assignment operator of DcmElement which could result in slicing the object.

Parameters

  rhs | - [in] The instance to copy from. Has to be of the same class type as "this" object

Returns
  EC_Normal if copying was successful, error otherwise

Reimplemented from DcmElement.

Reimplemented in DcmPixelSequence, and DcmFileFormat.

## ◆ getItem()

virtual DcmItem* DcmSequenceOfItems::getItem | ( | const unsigned long | num | ) |
| virtual

access an item from the sequence.

This method returns a pointer to one of the items in the list, and not a copy.

Parameters

  num | index number of item, must be < card()

Returns
  pointer to item if found, NULL if num >= card()

Reimplemented in DcmPixelSequence.

## ◆ getLength()

virtual Uint32 DcmSequenceOfItems::getLength | ( | const E_TransferSyntax | xfer = `EXS_LittleEndianImplicit`,
|  | const E_EncodingType | enctype = `EET_UndefinedLength`
| ) |  |
| virtual

calculate the value length (without attribute tag, VR and length field) of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences.

If length encoding is set to be explicit and the total sequence size is larger than the available 32-bit length field, then undefined length is returned. If "dcmWriteOversizedSeqsAndItemsImplicit" is disabled, also the internal DcmObject errorFlag is set to EC_SeqOrItemContentOverflow.

Parameters

  xfer | transfer syntax for length calculation
  enctype | sequence encoding type for length calculation

Returns
  value length of DICOM element

Reimplemented from DcmElement.

## ◆ getNumberOfValues()

virtual unsigned long DcmSequenceOfItems::getNumberOfValues | ( |  | ) |
| virtual

get number of values (items) stored in this sequence.

The result is the same as card() unless overwritten in a derived class.

Returns
  number of items in this sequence

Implements DcmObject.

## ◆ getPartialValue()

virtual OFCondition DcmSequenceOfItems::getPartialValue | ( | void * | targetBuffer,
|  | const Uint32 | offset,
|  | Uint32 | numBytes,
|  | DcmFileCache * | cache = `NULL`,
|  | E_ByteOrder | byteOrder = `gLocalByteOrder`
| ) |  |
| virtual

Copy numBytes bytes of data from the attribute value in byteOrder byte order to targetBuffer, starting at byte offset offset of the attribute value.

This method does not cause the complete attribute value to be read into main memory. Subsequent calls for the same partial value may cause repeated access to file if the attribute value is kept in file.

Parameters

  targetBuffer | pointer to target buffer, must not be NULL. Buffer size must be at least numBytes bytes.
  offset | byte offset within the attribute value from where to start copying
  numBytes | number of bytes to copy.
  cache | file cache object that may be passed to multiple subsequent calls to this method for the same file; the file cache will then keep a file handle open, thus improving performance. Optional, may be NULL
  byteOrder | byte order desired byte order of attribute value in memory buffer. Default is the local byte order of the machine.

Returns
  EC_Normal upon success, an error code otherwise

Reimplemented from DcmElement.

## ◆ getVM()

virtual unsigned long DcmSequenceOfItems::getVM | ( |  | ) |
| virtual

get value multiplicity

Returns
  always returns 1 (according to the DICOM standard)

Implements DcmObject.

## ◆ ident()

virtual DcmEVR DcmSequenceOfItems::ident | ( | void |  | ) | const
| inline virtual

return identifier for this class.

Every class derived from this class returns a unique value of type enum DcmEVR for this call. This is used as a "poor man's RTTI" to correctly identify instances derived from this class even on compilers not supporting RTTI.

Returns
  type identifier of this class

Implements DcmObject.

Reimplemented in DcmPixelSequence, and DcmFileFormat.

References EVR_SQ.

## ◆ insert()

virtual OFCondition DcmSequenceOfItems::insert | ( | DcmItem * | item,
|  | unsigned long | where = `DCM_EndOfListIndex`,
|  | OFBool | before = `OFFalse`
| ) |  |
| virtual

insert the given item at the given position within the item list maintained by this sequence.

Ownership of the item, which must be allocated on the heap, is transferred to the sequence.

Parameters

  item | pointer to DcmItem instance allocated on the heap, must not be NULL.
  where | index of the item after or before which the new item is to be inserted. Value must be < card() or equal to DCM_EndOfListIndex.
  before | indicates whether the new item should be inserted before or after the item identified by "where"

Returns
  EC_Normal if successful, an error code otherwise

Reimplemented in DcmPixelSequence.

## ◆ insertAtCurrentPos()

virtual OFCondition DcmSequenceOfItems::insertAtCurrentPos | ( | DcmItem * | item,
|  | OFBool | before = `OFFalse`
| ) |  |
| virtual

insert new item a current position.

The current position is stored internally in the 'itemList' member variable.

Parameters

  item | new item to be inserted
  before | flag indicating whether to insert the item before (OFFalse) or after (OFTrue) the current position

Returns
  status, EC_Normal upon success, an error code otherwise

## ◆ isAffectedBySpecificCharacterSet()

virtual OFBool DcmSequenceOfItems::isAffectedBySpecificCharacterSet | ( |  | ) | const
| virtual

check if this object is affected by SpecificCharacterSet at any nesting level.

In detail, it is checked whether this object contains any data elements that according to their VR are affected by the SpecificCharacterSet (0008,0005) element. This is true for the following VRs: PN, LO, LT, SH, ST, UC and UT

Returns
  true if object is affected by SpecificCharacterSet, false otherwise

Reimplemented from DcmObject.

## ◆ isEmpty()

virtual OFBool DcmSequenceOfItems::isEmpty | ( | const OFBool | normalize = `OFTrue` | ) |
| virtual

check if this sequence is empty

Parameters

  normalize | not used for this class

Returns
  true if sequence is empty, i.e. has no items, false otherwise

Reimplemented from DcmObject.

## ◆ isLeaf()

virtual OFBool DcmSequenceOfItems::isLeaf | ( |  | ) | const
| inline virtual

check if this element is a leaf node in a dataset tree.

All subclasses of DcmElement except for DcmSequenceOfItems are leaf nodes, while DcmSequenceOfItems, DcmItem, DcmDataset etc. are not.

Returns
  true if leaf node, false otherwise.

Reimplemented from DcmElement.

## ◆ isSignable()

virtual OFBool DcmSequenceOfItems::isSignable | ( |  | ) | const
| virtual

returns true if the current object may be included in a digital signature

Returns
  true if signable, false otherwise

Reimplemented from DcmObject.

## ◆ loadAllDataIntoMemory()

virtual OFCondition DcmSequenceOfItems::loadAllDataIntoMemory | ( | void |  | ) |
| virtual

this method loads all attribute values maintained by this object and all sub-objects (in case of a container such as DcmDataset) into memory.

After a call to this method, the file from which a dataset was read may safely be deleted or replaced. For large files, this method may obviously allocate large amounts of memory.

Returns
  EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

## ◆ makeSubObject()

virtual OFCondition DcmSequenceOfItems::makeSubObject | ( | DcmObject *& | subObject,
|  | const DcmTag & | newTag,
|  | const Uint32 | newLength
| ) |  |
| protected virtual

helper function for read().

Create sub-object (item, item delimiter or sequence delimiter) of the appropriate type depending on the tag.

Parameters

  subObject | upon success, a pointer to the newly created object is returned in this parameter
  newTag | tag of the sub-object to be created
  newLength | length of the sub-object to be created

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented in DcmPixelSequence.

## ◆ nextInContainer()

virtual DcmObject* DcmSequenceOfItems::nextInContainer | ( | const DcmObject * | obj | ) |
| virtual

this method is only used in container classes, that is, DcmItem and DcmSequenceOfItems.

It returns a pointer to the next object in the list AFTER the given object. If the caller passes NULL, a pointer to the first object in the list is returned. If the given object is not found, the given object is the last one in the list or the list is empty, NULL is returned.

Parameters

  obj | pointer to one object in the container; we are looking for the next entry after this one. NULL if looking for the first entry.

Returns
  pointer to next object in container or NULL if not found

Reimplemented from DcmObject.

## ◆ nextObject()

virtual OFCondition DcmSequenceOfItems::nextObject | ( | DcmStack & | stack,
|  | const OFBool | intoSub
| ) |  |
| virtual

this method enables a stack based, depth-first traversal of a complete hierarchical DICOM dataset (that is, classes derived from DcmItem or DcmSequenceOfItems).

With each call of this method, the next object in the tree is located and marked on the stack.

Parameters

  stack | "cursor" for current position in the dataset. The stack will contain a pointer to each dataset, sequence, item and element from the main dataset down to the current element, and is updated upon each call to this method. An empty stack is equivalent to a stack containing a pointer to this object only.
  intoSub | if true, the nextObject method will perform a hierarchical search through the dataset (depth-first), if false, only the current container object will be traversed (e.g., all elements of an item or all items of a sequence).

Returns
  EC_Normal if value length is correct, an error code otherwise

Reimplemented from DcmObject.

## ◆ operator=()

DcmSequenceOfItems& DcmSequenceOfItems::operator= | ( | const DcmSequenceOfItems & | obj | ) |

copy assignment operator

Parameters

  obj | element to be copied

Returns
  reference to this object

## ◆ prepend()

virtual OFCondition DcmSequenceOfItems::prepend | ( | DcmItem * | item | ) |
| virtual

insert the given item at the start of the item list maintained by this sequence.

Ownership of the item, which must be allocated on the heap, is transferred to the sequence.

Parameters

  item | pointer to DcmItem instance allocated on the heap, must not be NULL.

Returns
  EC_Normal if successful, an error code otherwise

## ◆ print()

virtual void DcmSequenceOfItems::print | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags = `0`,
|  | const int | level = `0`,
|  | const char * | pixelFileName = `NULL`,
|  | size_t * | pixelCounter = `NULL`
| ) |  |
| virtual

print object to a stream

Parameters

  out | output stream
  flags | optional flag used to customize the output (see DCMTypes::PF_xxx)
  level | current level of nested items. Used for indentation.
  pixelFileName | not used (used in certain sub-classes of this class)
  pixelCounter | not used (used in certain sub-classes of this class)

Implements DcmObject.

Reimplemented in DcmPixelSequence, and DcmFileFormat.

## ◆ read()

virtual OFCondition DcmSequenceOfItems::read | ( | DcmInputStream & | inStream,
|  | const E_TransferSyntax | xfer,
|  | const E_GrpLenEncoding | glenc = `EGL_noChange`,
|  | const Uint32 | maxReadLength = `DCM_MaxReadLength`
| ) |  |
| virtual

This function reads the information of all attributes which are captured in the input stream and captures this information in elementList.

Each attribute is represented as an element in this list. If not all information for an attribute could be read from the stream, the function returns EC_StreamNotifyClient.

Parameters

  inStream | The stream which contains the information.
  xfer | The transfer syntax which was used to encode the information in inStream.
  glenc | Encoding type for group length; specifies what will be done with group length tags.
  maxReadLength | Maximum read length for reading an attribute value.

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmFileFormat, and DcmPixelSequence.

## ◆ readSubItem()

OFCondition DcmSequenceOfItems::readSubItem | ( | DcmInputStream & | inStream,
|  | const DcmTag & | newTag,
|  | const Uint32 | newLength,
|  | const E_TransferSyntax | xfer,
|  | const E_GrpLenEncoding | glenc,
|  | const Uint32 | maxReadLength = `DCM_MaxReadLength`
| ) |  |
| protected

helper function for read().

Create sub-object (item or pixel item) and call read() for this sub-object.

Parameters

  inStream | The stream which contains the information.
  newTag | attribute tag for sub-object
  newLength | length of the sub-object to be created
  xfer | The transfer syntax which was used to encode the information in inStream.
  glenc | Encoding type for group length; specifies what will be done with group length tags.
  maxReadLength | Maximum read length for reading an attribute value.

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ readTagAndLength()

virtual OFCondition DcmSequenceOfItems::readTagAndLength | ( | DcmInputStream & | inStream,
|  | const E_TransferSyntax | xfer,
|  | DcmTag & | tag,
|  | Uint32 & | length
| ) |  |
| protected virtual

This function reads tag and length information from inStream and returns this information to the caller.

When reading information, the transfer syntax which was passed is accounted for. If the transfer syntax shows an explicit value representation, the data type of this object is also read from the stream. In general, this function follows the rules which are specified in the DICOM standard (see DICOM standard (year 2000) part 5, section 7) (or the corresponding section in a later version of the standard) concerning the encoding of a dataset.

Parameters

  inStream | The stream which contains the information.
  xfer | The transfer syntax which was used to encode the information in inStream.
  tag | Contains in the end the tag that was read.
  length | Contains in the end the length value that was read.

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ remove() [1/2]

virtual DcmItem* DcmSequenceOfItems::remove | ( | const unsigned long | num | ) |
| virtual

remove item from list.

If found, the item is not deleted but returned to the caller who is responsible for further management of the DcmItem object.

Parameters

  num | index number of item, must be < card()

Returns
  pointer to DcmItem if found, NULL otherwise

Reimplemented in DcmPixelSequence, and DcmFileFormat.

## ◆ remove() [2/2]

virtual DcmItem* DcmSequenceOfItems::remove | ( | DcmItem * | item | ) |
| virtual

remove item from list.

If found, the item is not deleted but returned to the caller who is responsible for further management of the DcmItem object.

Parameters

  item | pointer to item to be removed from list

Returns
  pointer to item if found, NULL otherwise

Reimplemented in DcmFileFormat, and DcmPixelSequence.

## ◆ search()

virtual OFCondition DcmSequenceOfItems::search | ( | const DcmTagKey & | xtag,
|  | DcmStack & | resultStack,
|  | E_SearchMode | mode = `ESM_fromHere`,
|  | OFBool | searchIntoSub = `OFTrue`
| ) |  |
| virtual

a complex, stack-based, hierarchical search method.

It allows for a search for a DICOM object with a given attribute within a given container, hierarchically, from a starting position identified through a cursor stack.

Parameters

  xtag | the DICOM attribute tag we are searching for
  resultStack | Depending on the search mode (see below), this parameter either serves as an input and output parameter, or as an output parameter only (the latter being the default). When used as an input parameter, the cursor stack defines the start position for the search within a hierarchical DICOM dataset. Upon successful return, the stack contains the position of the element found, in the form of a pointer to each dataset, sequence, item and element from the main dataset down to the found element.
  mode | search mode, controls how the search stack is handled. In the default mode, ESM_fromHere, the stack is ignored on input, and the search starts in the object for which this method is called. In the other modes, the stack is used both as an input and an output parameter and defines the starting point for the search.
  searchIntoSub | if true, the search will be performed hierarchically descending into the sequences and items of the dataset. If false, only the current container (sequence or item) will be traversed.

Returns
  EC_Normal if found, EC_TagNotFound if not found, an error code is something went wrong.

Reimplemented from DcmObject.

## ◆ searchSubFromHere()

virtual OFCondition DcmSequenceOfItems::searchSubFromHere | ( | const DcmTagKey & | tag,
|  | DcmStack & | resultStack,
|  | const OFBool | searchIntoSub
| ) |  |
| protected virtual

helper function for search().

May only be called if item list is non-empty. Performs hierarchical search for given tag and pushes pointer of sub-element on result stack if found

Parameters

  tag | tag key to be searched
  resultStack | upon successful return, pointer to element pushed onto this stack
  searchIntoSub | flag indicating whether recursive search is desired

Returns
  EC_Normal if tag found and stack modified, EC_TagNotFound if tag not found and stack unmodified

## ◆ transferEnd()

virtual void DcmSequenceOfItems::transferEnd | ( |  | ) |
| virtual

finalize the transfer state of this object.

This method must be called when reading/writing this object from/to a stream has been completed.

Reimplemented from DcmObject.

## ◆ transferInit()

virtual void DcmSequenceOfItems::transferInit | ( |  | ) |
| virtual

initialize the transfer state of this object.

This method must be called before this object is written to a stream or read (parsed) from a stream.

Reimplemented from DcmElement.

## ◆ verify()

virtual OFCondition DcmSequenceOfItems::verify | ( | const OFBool | autocorrect = `OFFalse` | ) |
| virtual

check the currently stored element value

Parameters

  autocorrect | correct value length if OFTrue

Returns
  status, EC_Normal if value length is correct, an error code otherwise

Implements DcmObject.

## ◆ write()

virtual OFCondition DcmSequenceOfItems::write | ( | DcmOutputStream & | outStream,
|  | const E_TransferSyntax | oxfer,
|  | const E_EncodingType | enctype,
|  | DcmWriteCache * | wcache
| ) |  |
| virtual

write object to a stream

Parameters

  outStream | DICOM output stream
  oxfer | output transfer syntax
  enctype | encoding types (undefined or explicit length)
  wcache | pointer to write cache object, may be NULL

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmPixelSequence, and DcmFileFormat.

## ◆ writeJson()

virtual OFCondition DcmSequenceOfItems::writeJson | ( | STD_NAMESPACE ostream & | out,
|  | DcmJsonFormat & | format
| ) |  |
| virtual

write object in JSON format

Parameters

  out | output stream to which the JSON document is written
  format | used to format and customize the output

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmPixelSequence, and DcmFileFormat.

## ◆ writeSignatureFormat()

virtual OFCondition DcmSequenceOfItems::writeSignatureFormat | ( | DcmOutputStream & | outStream,
|  | const E_TransferSyntax | oxfer,
|  | const E_EncodingType | enctype,
|  | DcmWriteCache * | wcache
| ) |  |
| virtual

special write method for creation of digital signatures

Parameters

  outStream | DICOM output stream
  oxfer | output transfer syntax
  enctype | encoding types (undefined or explicit length)
  wcache | pointer to write cache object, may be NULL

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmPixelSequence.

## ◆ writeTagAndVR()

static OFCondition DcmSequenceOfItems::writeTagAndVR | ( | DcmOutputStream & | outStream,
|  | const DcmTag & | tag,
|  | DcmEVR | vr,
|  | const E_TransferSyntax | oxfer
| ) |  |
| static private

static helper method used in writeSignatureFormat().

This function resembles DcmObject::writeTagAndLength() but only writes the tag, VR and reserved field.

Parameters

  outStream | stream to write to
  tag | attribute tag
  vr | attribute VR as reported by getVR
  oxfer | output transfer syntax

Returns
  EC_Normal if successful, an error code otherwise

## ◆ writeXML()

virtual OFCondition DcmSequenceOfItems::writeXML | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags = `0`
| ) |  |
| virtual

write object in XML format

Parameters

  out | output stream to which the XML document is written
  flags | optional flag used to customize the output (see DCMTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmElement.

Reimplemented in DcmPixelSequence, and DcmFileFormat.

## Member Data Documentation

## ◆ fStartPosition

offile_off_t DcmSequenceOfItems::fStartPosition
| private

used during reading.

Contains the position in the stream where the sequence started (needed for calculating the remaining number of bytes available for a fixed-length sequence).

## ◆ lastItemComplete

OFBool DcmSequenceOfItems::lastItemComplete
| private

flag used during suspended I/O.

Indicates whether the last item was completely or only partially read/written during the last call to read/write.

The documentation for this class was generated from the following file:

- dcmdata/include/dcmtk/dcmdata/dcsequen.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1